#include <iostream>  
using namespace std;


void foo(int x)
{
	// pass-by-value 
	// (*)
	x++;
}

void bar(int &x)
{
	//  pass-by-ref
	// (**)
	x++;
}



int main()
{

	int a = 10;
	int b = 42;
	int &c = b; // Make c a reference to b
	//int c = b; // Make c a different int to b

	cout << "a = " << a << endl;
	cout << "b = " << b << endl;
	cout << "c = " << c << endl << endl;
	foo(a);

	cout << "a = " << a << endl;
	cout << "b = " << b << endl;
	cout << "c = " << c << endl << endl;
	bar(a);
	bar(b);

	cout << "a = " << a << endl;
	cout << "b = " << b << endl;
	cout << "c = " << c << endl << endl;

	c = 14;
	cout << "a = " << a << endl;
	cout << "b = " << b << endl;
	cout << "c = " << c << endl << endl;



	return 0;
}


